"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthorizationPolicy = void 0;
const IoK8sApimachineryPkgApisMetaV1ObjectMeta_1 = require("@kubernetes-models/apimachinery/_schemas/IoK8sApimachineryPkgApisMetaV1ObjectMeta");
const base_1 = require("@kubernetes-models/base");
const validate_1 = require("@kubernetes-models/validate");
const schemaId = "policy.linkerd.io.v1alpha1.AuthorizationPolicy";
const schema = {
    "type": "object",
    "properties": {
        "spec": {
            "type": "object",
            "required": [
                "targetRef",
                "requiredAuthenticationRefs"
            ],
            "properties": {
                "targetRef": {
                    "type": "object",
                    "required": [
                        "kind",
                        "name"
                    ],
                    "properties": {
                        "group": {
                            "maxLength": 253,
                            "type": "string",
                            "pattern": "^$|^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$",
                            "nullable": true
                        },
                        "kind": {
                            "maxLength": 63,
                            "minLength": 1,
                            "type": "string",
                            "pattern": "^[a-zA-Z]([-a-zA-Z0-9]*[a-zA-Z0-9])?$"
                        },
                        "name": {
                            "maxLength": 253,
                            "minLength": 1,
                            "type": "string"
                        }
                    }
                },
                "requiredAuthenticationRefs": {
                    "type": "array",
                    "items": {
                        "type": "object",
                        "required": [
                            "kind",
                            "name"
                        ],
                        "properties": {
                            "group": {
                                "maxLength": 253,
                                "type": "string",
                                "pattern": "^$|^[a-z0-9]([-a-z0-9]*[a-z0-9])?(\\.[a-z0-9]([-a-z0-9]*[a-z0-9])?)*$",
                                "nullable": true
                            },
                            "kind": {
                                "maxLength": 63,
                                "minLength": 1,
                                "type": "string",
                                "pattern": "^[a-zA-Z]([-a-zA-Z0-9]*[a-zA-Z0-9])?$"
                            },
                            "name": {
                                "maxLength": 253,
                                "minLength": 1,
                                "type": "string"
                            },
                            "namespace": {
                                "maxLength": 253,
                                "type": "string",
                                "nullable": true
                            }
                        }
                    }
                }
            }
        },
        "apiVersion": {
            "type": "string",
            "enum": [
                "policy.linkerd.io/v1alpha1"
            ]
        },
        "kind": {
            "type": "string",
            "enum": [
                "AuthorizationPolicy"
            ]
        },
        "metadata": {
            "oneOf": [
                {
                    "$ref": "io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta#"
                },
                {
                    "type": "null"
                }
            ]
        }
    },
    "required": [
        "spec",
        "apiVersion",
        "kind"
    ]
};
class AuthorizationPolicy extends base_1.Model {
    constructor(data) {
        super({
            apiVersion: AuthorizationPolicy.apiVersion,
            kind: AuthorizationPolicy.kind,
            ...data
        });
    }
}
exports.AuthorizationPolicy = AuthorizationPolicy;
AuthorizationPolicy.apiVersion = "policy.linkerd.io/v1alpha1";
AuthorizationPolicy.kind = "AuthorizationPolicy";
AuthorizationPolicy.is = (0, base_1.createTypeMetaGuard)(AuthorizationPolicy);
(0, base_1.setSchema)(AuthorizationPolicy, schemaId, () => {
    (0, IoK8sApimachineryPkgApisMetaV1ObjectMeta_1.addSchema)();
    (0, validate_1.register)(schemaId, schema);
});
