"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NetworkAuthentication = void 0;
const IoK8sApimachineryPkgApisMetaV1ObjectMeta_1 = require("@kubernetes-models/apimachinery/_schemas/IoK8sApimachineryPkgApisMetaV1ObjectMeta");
const base_1 = require("@kubernetes-models/base");
const validate_1 = require("@kubernetes-models/validate");
const schemaId = "policy.linkerd.io.v1alpha1.NetworkAuthentication";
const schema = {
    "type": "object",
    "properties": {
        "spec": {
            "type": "object",
            "required": [
                "networks"
            ],
            "properties": {
                "networks": {
                    "type": "array",
                    "items": {
                        "type": "object",
                        "required": [
                            "cidr"
                        ],
                        "properties": {
                            "cidr": {
                                "type": "string"
                            },
                            "except": {
                                "type": "array",
                                "items": {
                                    "type": "string"
                                },
                                "nullable": true
                            }
                        }
                    }
                }
            }
        },
        "apiVersion": {
            "type": "string",
            "enum": [
                "policy.linkerd.io/v1alpha1"
            ]
        },
        "kind": {
            "type": "string",
            "enum": [
                "NetworkAuthentication"
            ]
        },
        "metadata": {
            "oneOf": [
                {
                    "$ref": "io.k8s.apimachinery.pkg.apis.meta.v1.ObjectMeta#"
                },
                {
                    "type": "null"
                }
            ]
        }
    },
    "required": [
        "spec",
        "apiVersion",
        "kind"
    ]
};
class NetworkAuthentication extends base_1.Model {
    constructor(data) {
        super({
            apiVersion: NetworkAuthentication.apiVersion,
            kind: NetworkAuthentication.kind,
            ...data
        });
    }
}
exports.NetworkAuthentication = NetworkAuthentication;
NetworkAuthentication.apiVersion = "policy.linkerd.io/v1alpha1";
NetworkAuthentication.kind = "NetworkAuthentication";
NetworkAuthentication.is = (0, base_1.createTypeMetaGuard)(NetworkAuthentication);
(0, base_1.setSchema)(NetworkAuthentication, schemaId, () => {
    (0, IoK8sApimachineryPkgApisMetaV1ObjectMeta_1.addSchema)();
    (0, validate_1.register)(schemaId, schema);
});
